Index: /XIOS/dev/dev_ym/XIOS_COUPLING/extern/remap/src/polyg.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/extern/remap/src/polyg.cpp	(revision 2281)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/extern/remap/src/polyg.cpp	(revision 2282)
@@ -98,4 +98,7 @@
   else if (n == 2) return midpoint(x[0], x[1]);
   else if (n == 1) return x[0];
+
+  error_exit( "Missing return in : Coord exact_barycentre(const Coord *x, int n)" );
+  return ORIGIN;
 }
 
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/cxios.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/cxios.cpp	(revision 2281)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/cxios.cpp	(revision 2282)
@@ -310,4 +310,7 @@
     if (isClient) return CClient::getPoolRessource() ;
     else if (isServer) return CServer::getServersRessource()->getPoolRessource() ;
+    
+    MISSING_RETURN( "CPoolRessource* CXios::getPoolRessource()" );
+    return nullptr;
   }
 }
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/server_distribution_description.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/server_distribution_description.cpp	(revision 2281)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/server_distribution_description.cpp	(revision 2282)
@@ -39,5 +39,8 @@
     default:
       break;
-  } 
+  }
+
+  MISSING_RETURN( "int CServerDistributionDescription::defaultDistributedDimension(int gridDimension, ServerDistributionType serType)" );
+  return -1;
 }
 
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/exception.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/exception.hpp	(revision 2281)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/exception.hpp	(revision 2282)
@@ -75,4 +75,12 @@
        xios::CException exc(id);                \
        exc.getStream() << INFO(x);              \
+       error << exc.getMessage() << std::endl;  \
+       throw exc;                               \
+}
+
+#define MISSING_RETURN(id)  \
+{                     \
+       xios::CException exc(id);                \
+       exc.getStream() << INFO("Missing return");              \
        error << exc.getMessage() << std::endl;  \
        throw exc;                               \
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/axis.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/axis.hpp	(revision 2281)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/axis.hpp	(revision 2282)
@@ -209,4 +209,7 @@
            if (hasDirectAxisReference()) if (!getDirectAxisReference()->isCompleted()) return false;
            else return isCompleted_ ;
+
+           MISSING_RETURN( "bool CAxis::isCompleted() " );
+           return true;
          }
          void setCompleted(void) { isCompleted_=true ; }
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/domain.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/domain.hpp	(revision 2281)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/domain.hpp	(revision 2282)
@@ -175,4 +175,7 @@
            if (hasDirectDomainReference()) if (!getDirectDomainReference()->isCompleted()) return false;
            else return isCompleted_ ;
+
+           MISSING_RETURN( "bool CDomain::isCompleted() " );
+           return true;
          }
          void setCompleted(void) { isCompleted_=true ; }
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.cpp	(revision 2281)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.cpp	(revision 2282)
@@ -461,4 +461,7 @@
       }  
     }
+
+    MISSING_RETURN( "CDomain* CGrid::getAssociatedDomain(const string& domainId, bool noError)" );
+    return nullptr;
   } 
 
@@ -525,4 +528,7 @@
       }  
     }
+
+    MISSING_RETURN( "CAxis* CGrid::getAssociatedAxis(const string& axisId, bool noError)" );
+    return nullptr;
   } 
 
@@ -589,4 +595,7 @@
       }  
     }
+
+    MISSING_RETURN( "CScalar* CGrid::getAssociatedScalar(const string& scalarId, bool noError)" );
+    return nullptr;
   } 
 
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/scalar.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/scalar.hpp	(revision 2281)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/scalar.hpp	(revision 2282)
@@ -167,4 +167,7 @@
         if (hasDirectScalarReference()) if (!getDirectScalarReference()->isCompleted()) return false;
         else return isCompleted_ ;
+
+        MISSING_RETURN( "bool CAxis::isCompleted() " );
+        return true;
       }
       void setCompleted(void) { isCompleted_=true ; }
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/axis_algorithm/axis_algorithm_interpolate_coordinate.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/axis_algorithm/axis_algorithm_interpolate_coordinate.cpp	(revision 2281)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/axis_algorithm/axis_algorithm_interpolate_coordinate.cpp	(revision 2282)
@@ -69,4 +69,7 @@
     }
     if (pos==1) return false ;
+
+    MISSING_RETURN( "bool CAxisAlgorithmInterpolateCoordinate::transformAuxField(int pos)" );
+    return false;
   }
 